#include <iostream>
#include <pthread.h>

#define PLACES_DISPONIBLES 5
#define NOMBRE_TOURS 5

#define N 11 // nombre de passagers
#define C  5 // nombre de passagers par voiture
#define T  5 // nombre de tours de manège
    
int personnesAssises = 0;
int etatManege = 0;

pthread_cond_t pasPlein, peutSortir, peutPartir, peutRetournerEnFile;
pthread_mutex_t pasPleinM, peutSortirM, peutPartirM, peutRetournerEnFileM;
pthread_mutex_t semPlacesLibres[C], semFinManege[C], semVoiturePleine[C];

void prendrePlaceDansManege(int noPassager){
	
	if (personnesAssises == PLACES_DISPONIBLES){
		pthread_cond_wait(&pasPlein,&pasPleinM);
	}
	printf("passager %d s'assoit",noPassager);
	personnesAssises++;
	if(personnesAssises == PLACES_DISPONIBLES){
		pthread_cond_signal(&peutPartir);
	}
}
void sortirDuManege(int noPassager){
	if( etatManege == 0 ){
		pthread_cond_wait(&peutSortir,&peutSortirM); 
	}
	printf("passager %d sort du manege", noPassager);
	personnesAssises--;
	pthread_cond_wait(&peutRetournerEnFile,&peutRetournerEnFileM);

}
   
void faireToursDeManege(){
	etatManege = 0;
	if( personnesAssises < PLACES_DISPONIBLES){
		pthread_cond_wait(&peutPartir,&peutPartirM);
	}
	printf("manege demarre");
	for(int i =1;i<=NOMBRE_TOURS;i++){
		printf("tour %d",i);
		sleep(1000);
	}
	
	printf("manege arrete");
	for(int i=1; i<=PLACES_DISPONIBLES;i++){pthread_cond_signal(&peutSortir);}
	for(int i=1; i<=PLACES_DISPONIBLES;i++){pthread_cond_signal(&pasPlein);}
	for(int i=1; i<=PLACES_DISPONIBLES;i++){pthread_cond_signal(&peutRetournerEnFile);}
}

void *passager(void *no){
	int noPassager = (int)no;
	while(true){
		// essaye d'entrer dans la voiture
		pthread_mutex_lock(&semPlacesLibres[noPassager]);
		//le passager prend place
		pthread_mutex_unlock(&semVoiturePleine[noPassager]);
		printf("passager %d assis",noPassager);
		//attend que le voyage se termine
		pthread_mutex_lock(&semFinManege[noPassager]);
		printf("passager %d sort du manege",noPassager);
		pthread_mutex_unlock(&semPlacesLibres[noPassager]);
	}
}

int main(int argc, char** argv)
{	
	/* initialisation des variables condition*/
	pthread_cond_init(&pasPlein,NULL);
	pthread_cond_init(&peutSortir,NULL);
	pthread_cond_init(&peutPartir,NULL);
	pthread_cond_init(&peutRetournerEnFile,NULL);
	
	pthread_mutex_init(&pasPleinM,NULL);	
	pthread_mutex_init(&peutSortirM,NULL);	
	pthread_mutex_init(&peutPartirM,NULL);	
	pthread_mutex_init(&peutRetournerEnFileM,NULL);	
	for(int i=0;i<C;i++){
		pthread_mutex_init(&semPlacesLibres[i],NULL);
		pthread_mutex_init(&semFinManege[i],NULL);
		pthread_mutex_init(&semVoiturePleine[i],NULL);
	}
		
	pthread_t threadPassagers[N];
	for(int i=0;i<N;i++){
		pthread_create(&threadPassagers[i],NULL,passager,(void*)i);
	}
	
	while(true){
		printf("remplissage voiture");
		for(int i = 0;i<C;i++){
			pthread_mutex_lock(&semVoiturePleine[i]);
		}
		printf("depart du manege");
		for(int i = 0;i<T;i++){
			printf("Tour : %d", i);
			sleep(1000);
		}
		printf("fin du manege");
		for(int i = 0;i<C;i++){
			pthread_mutex_unlock(&semFinManege[i]);
		}
	}	
	
	return 0;
}
