﻿using System;
using System.Security.AccessControl;
using System.Threading;

class ManegeSem
{
    private const int nbPlaces = 6, nbPersonnes = 20;
    public static Semaphore places, voiture, tours;

    private static void Main(string[] args)
    {
        // Initialisation des sémaphores. Au départ on veut les places libres
        places = new Semaphore(nbPlaces, nbPlaces);
        voiture = new Semaphore(0, nbPlaces);
        tours = new Semaphore(0, nbPlaces);

        // Pars le nombre de threads voulus (nombre de personnes)
        for (int i = 1; i <= nbPersonnes; i++)
            new Thread (Passager).Start(i);

        // Laisses le temps à tous les threads de démarrer correctement
        Thread.Sleep(500);

        while (true)
        {
            // On attend que toutes les places de la voiture soient prises
            for (int i = 1; i <= nbPlaces; i++)
                voiture.WaitOne();

            Console.WriteLine("Tous les passagers sont embarqués, la voiture fait ses tours");
            Thread.Sleep(1500);
            Console.WriteLine("Les tours sont terminés");

            tours.Release(nbPlaces);    // Libère les passagers qui attendaient la fin des tours
            places.Release(nbPlaces);   // Libère les places pour les prochains passagers
        }
    }

    private static void Passager(object no)
    {
        while (true)
        {
            places.WaitOne();       // Passager embarque dans la voiture quand il y a des sièges disponibles
            Console.WriteLine("Passager {0} embarque dans la voiture", no);
            voiture.Release();      // Passager indique à la voiture de peut-être continuer
            tours.WaitOne();        // Bloque le passager dans le manège en attendant que le tour soit terminé
        }
    }
}
