using System;

public class Master
{
    private static JacobiRemoteService.Transfer transfer = null;
    private static String computerAddress = "localhost";
    private static String tcpPort = "1500";

    private const int matrixSize = 6;
    private const int border = -1;
    private const int maxIterations = 100;
    private const double epsilon = 0.01;
    private static Matrix matrix;
    private static Matrix matrixResults;

    public static void Main()
    {
        matrix = new Matrix(matrixSize, matrixSize);
        matrixResults = new Matrix(matrixSize, matrixSize);

        matrix.initialiseJacobi(border, 1, 4);
        matrixResults.initialiseJacobi(border, 1, 4);

        JacobiRemoteService.Response response;
        JacobiRemoteService.Request request = new JacobiRemoteService.Request();
        request.fin = false;

        int iteration = 0;

        string url = string.Format("tcp://{0}:{1}/TestService", computerAddress, tcpPort);

        try
        {
            transfer = (JacobiRemoteService.Transfer)Activator.GetObject(typeof(JacobiRemoteService.Transfer), url);

            Console.WriteLine("En attente d'ouverture d'esclaves, appuyez sur Enter une fois que c'est fait");
            Console.ReadLine();

            do
            {
                matrix.initialise(matrixResults);
                iteration++;

                for (int i = 0; i < matrix.getNumLignes() * matrix.getNumColonnes(); i++)
                {
                    request.voisins = matrix.getVoisins(i / matrix.getNumColonnes(), i % matrix.getNumColonnes());
                    request.index = i;
                    response = transfer.CalculerVoisins(request);

                    matrixResults.setValeur(response.index / matrix.getNumColonnes(), response.index % matrix.getNumColonnes(), response.valeur);
                }

                Console.WriteLine("Iteration {0} :", iteration);
                PrintMatrix(matrixResults);
            } while ((!matrixResults.epsilonAtteint(matrix, epsilon)) && (iteration < maxIterations));

            if (iteration == maxIterations)
                Console.WriteLine("Maximum d'itrations atteint");

            request.fin = true;
            response = transfer.CalculerVoisins(request);

            Console.ReadLine();
        }
        catch (Exception Ex)
        {
            Console.WriteLine("Erreur d'envoi du message du matre  l'esclave:\n" + Ex.Message, "Erreur Master");
            Console.ReadLine();
        }
    }

    private static void PrintMatrix(Matrix mat)
    {
        String matrixPrint = "";

        for (int i = 0; i < mat.getNumLignes(); i++)
        {
            matrixPrint += " ";
            for (int j = 0; j < mat.getNumColonnes(); j++)
                matrixPrint += string.Format("{0} ", Math.Round(mat.getValeur(i, j), 4));
            Console.WriteLine(matrixPrint);
            matrixPrint = "";
        }
    }
}