﻿using System;

namespace JacobiRemoteService
{
    [Serializable]
    public struct Request
    {
        public int index;
        public double[] voisins;
        public bool fin;
    };

    [Serializable]
    public struct Response
    {
        public double valeur;
        public int index;
        public int slaveId;
        public String message;
    };

    public class Transfer : MarshalByRefObject
    {
        public delegate Response delegateSlaveCall(Request action);
        public event delegateSlaveCall slaveCall;

        public Transfer()
        {
        }

        public Response CalculerVoisins(Request action)
        {
            return slaveCall(action);
        }

        /// <summary>
        /// This override is EXTREMELY important
        /// If it is missing the garbage collector of the Slave will delete the Transfer object
        /// after 5 minutes and the event will be lost, so further calls to the slave will return
        /// "Server encountered an internal error" (a very helpful Microsoft error message!)
        /// This function sets the livetime to infinite
        /// See http://www.thinktecture.com/Resources/RemotingFAQ/SINGLETON_IS_DYING.html
        /// </summary>
        public override Object InitializeLifetimeService()
        {
            return null;
        }
    }
}
