#!/usr/bin/env ruby -w
# Fichier contenant le maitre du calcul de jacobi
# Marc Michaud

require 'thread'

require 'matrice_jacobi'
require 'thread'

require 'rinda/ring'

DRb.start_service
ring_server = Rinda::RingFinger.primary

ts = ring_server.read([:name, :TupleSpace, nil, nil])[2]
ts = Rinda::TupleSpaceProxy.new ts


class Jacobizer
  def initialize (ts)
    @mat = MatriceJacobi.new(28, 28, 0, 0, 0.01)
    @prev = @mat.deep_clone
    #@prev = MatriceJacobi.new(5, 27, 0, 0, 0.01)
    @total = @mat.getnumcolonnes * @mat.getnumlignes
    
    @semSuivant = Mutex.new
    @suivant=0
    @ts=ts
  end

  def obtenirTravail(i)
    if (i < @total)
      return @prev.getvoisins((i / @mat.getnumcolonnes).floor, i % @mat.getnumcolonnes)
    else
      return nil
    end
  end
  
  def iterer()
    n=0
    puts "début"
    @prev.afficher
    begin
      #@prev = @mat.deep_clone
      temp = @mat
      @mat = @prev
      @prev = temp
      for i in 0..@total-1
        v1,v2,v3,v4 = obtenirTravail(i)
        # envoi
        @ts.write(['travail', i, v1, v2, v3, v4])
      end
      for i in 0..@total-1
        # reception
        ans = @ts.take(['retour', nil, nil])
        @mat.setvaleur((ans[1] / @mat.getnumcolonnes).floor, ans[1] % @mat.getnumcolonnes, ans[2])
      end
      n+=1
      puts "Fin de l'iteration " + n.to_s
      @mat.afficher
    end while (!@mat.epsilonatteint(@prev))
    puts "Fin en " + n.to_s + " itérations"
    @ts.write(['fin'])
  end
  
end

jacobizer = Jacobizer.new(ts)
jacobizer.iterer()

