#!/usr/bin/ruby -d
# Implementation du probleme du manege a l'aide des moniteurs
# Marc Michaud

require 'monitor'
require 'thread'

n=21
c=5
t=5

class Manege < Monitor
  def initialize (c=5, t=5)
    super()
    @placesDisponibles = c
    @nombreTours = t
    @personneAssises = 0
    @personneSortie = @placesDisponibles
    @etatManege = 0 # 0:remplissage en cours, 1:en route, 2:vidage en cours
    
    @peutSortir = new_cond
    @peutPartir = new_cond
    @peutRetournerEnFile = new_cond
    @toutLeMondeSorti = new_cond
    @peutEntrer = new_cond
  end

  def prendrePlaceDansManege(x)
    enter
    @peutEntrer.wait  while (@etatManege != 0 || (@personneAssises == @placesDisponibles))
    @personneAssises += 1
    puts "passager " + x.to_s + " s'assoit" # (" + @personneAssises.to_s + "/" + @placesDisponibles.to_s + ") (" + @personneSortie.to_s + "/" + @placesDisponibles.to_s + ")"
    @peutPartir.signal if (@personneAssises == @placesDisponibles &&  @personneSortie==@placesDisponibles)
    exit
  end

  def sortirDuManege (x)
    enter
    @peutSortir.wait_until {(@etatManege == 2)}
    @personneAssises -= 1
    @personneSortie += 1
    puts "passager " + x.to_s + " sort" # (" + @personneAssises.to_s + "/" + @placesDisponibles.to_s + ") (" + @personneSortie.to_s + "/" + @placesDisponibles.to_s + ")"
    @toutLeMondeSorti.signal  if (@personneSortie == @placesDisponibles)
    exit
  end
  
  def faireToursDeManege
    enter
    @peutPartir.wait_while  { (@personneAssises < @placesDisponibles || @personneSortie < @placesDisponibles) }
    @etatManege = 1
    @personneSortie = 0;
    puts "manege demarre"
    for i in 1..@nombreTours
      sleep 0.2
      puts "Tour : " + i.to_s
    end
    puts "manege arrete"
    @etatManege = 2
    for i in 1..@placesDisponibles
      @peutSortir.signal
    end
    @toutLeMondeSorti.wait  while (@personneSortie < @placesDisponibles)
    @etatManege = 0
    for i in 1..@placesDisponibles
      @peutEntrer.signal
    end
    exit
  end
  
end

$manege = Manege.new(c,t)

def passager(x)
  while(true)
    $manege.prendrePlaceDansManege(x)
    $manege.sortirDuManege(x)
    
  end
end

def voiture()
  while(true)
    $manege.faireToursDeManege
  end
end

threads=[]
for i in 1..n
  threads[i-1]= Thread.new {passager(i)}  
end
thread_voiture= Thread.new {voiture}
for i in 0..4
  threads[i].join
end
thread_voiture.join
