# 
# Implementation des philosophes a l'aide des moniteurs
# Marc Michaud
require 'monitor'
require 'thread'

class PhilosophesMoniteurs < Monitor
   def initialize ()
    super()
    srand
    @etat=[] # 0:pense 1:a faim, 2:mange
    @attente=[]
    for i in 0..4
      @attente[i] = new_cond
      @etat[i] = 0
    end 
    @compteur=0
  end

  def tester(x)
    if ((@etat[(x+1) % 5] != 2) && (@etat[(x+4) % 5] != 2) && (@etat[x] == 1))
      @etat[x] = 2
      @attente[x].signal
    end
  end
  
  def prendre(x)
    synchronize {
      @etat[x] = 1
      tester(x)
      @attente[x].wait if (@etat[x] != 2)
      puts "Le philosophe " + x.to_s + " mange"
    }
  end

  def deposer (x)
    synchronize {
      @etat[x] = 0
      tester((x + 4) % 5)
      tester((x + 1) % 5)
      puts "Le philosophe " + x.to_s + " pense"
    }
  end
end

$phils = PhilosophesMoniteurs.new

def philosopher(x)
  loop do
    sleep(1 *rand()) + 1.0
    puts "Le philosophe " + x.to_s + " a faim"
    $phils.prendre(x)
    sleep(2 * rand()) + 1.0
    $phils.deposer(x)
  end
end


threads=[]
for i in 0..4
  threads[i]= Thread.new {philosopher(i)}  
end

for i in 0..4
  threads[i].join
end


